//+------------------------------------------------------------------+
//|                                                                  |
//|                      |
//|       PPZ                                         |
//|                               http://www.mql4.com/ru/users/Dserg |
//+------------------------------------------------------------------+
#property  copyright "Dserg, 2010"
#property  link      "http://www.mql4.com/ru/users/Dserg"

//---- indicator settings
#property  indicator_chart_window
#property  indicator_buffers 4
#property indicator_color1 DeepSkyBlue
#property indicator_color2 HotPink
#property indicator_color3 Gold
#property indicator_color4 Tomato

//---- buffers
double B0[];
double B1[];
double B2[];
double B3[];

// ,    
extern int Nbars = 150;
//    
extern int Nfirst = 0;
//      
extern double minDiff = 300.0;
//      
extern int minBars = 5;

static bool calculated;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- 3additional buffers are used for counting.
   
//---- drawing settings

   SetIndexStyle(0,DRAW_ARROW,0,4);
   SetIndexBuffer(0, B0);      
   SetIndexArrow(0, 119);        
   SetIndexStyle(1,DRAW_ARROW,0,4);
   SetIndexBuffer(1, B1);      
   SetIndexArrow(1, 119);        
   SetIndexStyle(2,DRAW_ARROW,0,4);
   SetIndexBuffer(2, B2);      
   SetIndexArrow(2, 119);        
   SetIndexStyle(3,DRAW_ARROW,0,4);
   SetIndexBuffer(3, B3);      
   SetIndexArrow(3, 119);        

   SetIndexEmptyValue(0,0.0);   
   SetIndexEmptyValue(1,0.0);   
   SetIndexEmptyValue(2,0.0);   
   SetIndexEmptyValue(3,0.0);   
   
   SetIndexLabel(0,"PPZ 0");
   SetIndexLabel(1,"PPZ 1");
   SetIndexLabel(2,"PPZ 2");
   SetIndexLabel(3,"PPZ 3");
   
   calculated = false;
   return(0);
  } 

int deinit()
  {
   ObjectDelete("PPZ");
   ObjectDelete("PPZ1");
   ObjectDelete("PPZ2");
   ObjectDelete("PPZ3");
   ObjectDelete("V1");
   ObjectDelete("V2");
   Comment("");
   return(0);
  } 

int start()

  {
      if (calculated) return(0);
      if (Nbars>300) { 
         Comment("Too much bars to calulate, try < 300");
         return(0);
      }
      
      int counted_bars = IndicatorCounted(); 
 
      if (counted_bars < 0) return(-1); 
      if (counted_bars >= Bars) return(0);

      Comment("Calculating PPZ..");

      int loopbegin = Nbars+Nfirst;
 
      int i,j,k,l,imin,jmin,kmin,lmin,imin1,jmin1,kmin1,lmin1,imin2,jmin2,kmin2,lmin2,imin3,jmin3,kmin3,lmin3;
      double f0,f1,f2,f3,p0,s0,pmin,smin,pmin1,smin1,pmin2,smin2,pmin3,smin3;
      pmin = 10.0;
      smin = 10000.0;
      pmin1 = 20.0;
      smin1 = 20000.0;
      pmin2 = 30.0;
      smin2 = 30000.0;
      pmin3 = 40.0;
      smin3 = 40000.0;
      
      //   PPZ  4- 
      for(i = loopbegin; i > Nfirst; i--) {
        f0 = -1.0; 
        f0 = iFractals(NULL,0,MODE_UPPER,i);
        if (f0<=0.0 ) f0 = iFractals(NULL,0,MODE_LOWER,i);
        if (f0>0.0) {
          for(j = loopbegin; j > Nfirst; j--) { 
            f1=-1.0;
            f1 = iFractals(NULL,0,MODE_UPPER,j);
            if (f1<=0.0) f1 = iFractals(NULL,0,MODE_LOWER,j);
            if (f1>0.0 && f1!=f0) {
              for(k = loopbegin; k > Nfirst; k--) { 
                f2 = -1.0;
                f2 = iFractals(NULL,0,MODE_UPPER,k);
                if (f2<=0.0 ) f2 = iFractals(NULL,0,MODE_LOWER,k);
                if (f2 >0.0 && f2!=f0 && f2!=f1) {
                  for(l = loopbegin; l > Nfirst; l--) { 
                    f3 = -1.0;
                    f3 = iFractals(NULL,0,MODE_UPPER,l);
                    if (f3<=0.0 ) f3 = iFractals(NULL,0,MODE_LOWER,l);
                    if (f3 >0.0 && f3!=f0 && f2!=f1 && f3!=f2) {
                      p0 = (f0+f1+f2+f3)/4.0;
                      s0 = (f0-p0)*(f0-p0)+(f1-p0)*(f1-p0)+(f2-p0)*(f2-p0)+(f2-p0)*(f2-p0);
                      if (s0<smin && MathAbs(i-j)>minBars && MathAbs(i-k)>minBars && MathAbs(k-j)>minBars && MathAbs(i-l)>minBars && MathAbs(j-l)>minBars && MathAbs(k-l)>minBars) {
                         smin=s0;
                         pmin=p0;
                         imin=i;
                         jmin=j;
                         kmin=k;
                         lmin=l;
                      } 
                    }
                  }
                }
              }
            }
          }
        }       
      }

      //   PPZ  4- 
      for(i = loopbegin; i > Nfirst; i--) {
        f0 = -1.0; 
        f0 = iFractals(NULL,0,MODE_UPPER,i);
        if (f0<=0.0 ) f0 = iFractals(NULL,0,MODE_LOWER,i);
        if (f0>0.0 && i!=imin && i!=jmin && i!=kmin && i!=lmin) {
          for(j = loopbegin; j > Nfirst; j--) { 
            f1=-1.0;
            f1 = iFractals(NULL,0,MODE_UPPER,j);
            if (f1<=0.0) f1 = iFractals(NULL,0,MODE_LOWER,j);
            if (f1>0.0 && f1!=f0 && j!=imin && j!=jmin && j!=kmin && j!=lmin) {
              for(k = loopbegin; k > Nfirst; k--) { 
                f2 = -1.0;
                f2 = iFractals(NULL,0,MODE_UPPER,k);
                if (f2<=0.0 ) f2 = iFractals(NULL,0,MODE_LOWER,k);
                if (f2 >0.0 && f2!=f0 && f2!=f1 && k!=imin && k!=jmin && k!=kmin && k!=lmin) {
                  for(l = loopbegin; l > Nfirst; l--) { 
                    f3 = -1.0;
                    f3 = iFractals(NULL,0,MODE_UPPER,l);
                    if (f3<=0.0 ) f3 = iFractals(NULL,0,MODE_LOWER,l);
                    if (f3 >0.0 && f3!=f0 && f3!=f1 && l!=imin && l!=jmin && l!=kmin && l!=lmin) {
                      p0 = (f0+f1+f2+f3)/4.0;
                      s0 = (f0-p0)*(f0-p0)+(f1-p0)*(f1-p0)+(f2-p0)*(f2-p0)+(f3-p0)*(f3-p0);
                      if (s0<smin1 && MathAbs(p0-pmin)>minDiff*Point && MathAbs(i-j)>minBars && MathAbs(i-k)>minBars && MathAbs(k-j)>minBars && MathAbs(i-l)>minBars && MathAbs(j-l)>minBars && MathAbs(k-l)>minBars) {
                         smin1=s0;
                         pmin1=p0;
                         imin1=i;
                         jmin1=j;
                         kmin1=k;
                         lmin1=l;
                      } 
                    }
                  }
                }
              }
            }
          }
        }       
      }

      //   PPZ  4- 
      for(i = loopbegin; i > Nfirst; i--) {
        f0 = -1.0; 
        f0 = iFractals(NULL,0,MODE_UPPER,i);
        if (f0<=0.0 ) f0 = iFractals(NULL,0,MODE_LOWER,i);
        if (f0>0.0 && i!=imin && i!=jmin && i!=kmin && i!=lmin && i!=imin1 && i!=jmin1 && i!=kmin1 && i!=lmin1) {
          for(j = loopbegin; j > Nfirst; j--) { 
            f1=-1.0;
            f1 = iFractals(NULL,0,MODE_UPPER,j);
            if (f1<=0.0) f1 = iFractals(NULL,0,MODE_LOWER,j);
            if (f1>0.0 && f1!=f0 && j!=imin && j!=jmin && j!=kmin && j!=lmin && j!=imin1 && j!=jmin1 && j!=kmin1 && j!=lmin1) {
              for(k = loopbegin; k > Nfirst; k--) { 
                f2 = -1.0;
                f2 = iFractals(NULL,0,MODE_UPPER,k);
                if (f2<=0.0 ) f2 = iFractals(NULL,0,MODE_LOWER,k);
                if (f2 >0.0 && f2!=f0 && f2!=f1 && k!=imin && k!=jmin && k!=kmin && k!=lmin && k!=imin1 && k!=jmin1 && k!=kmin1 && k!=lmin1) {
                  for(l = loopbegin; l > Nfirst; l--) { 
                    f3 = -1.0;
                    f3 = iFractals(NULL,0,MODE_UPPER,l);
                    if (f3<=0.0 ) f3 = iFractals(NULL,0,MODE_LOWER,l);
                    if (f3 >0.0 && f3!=f0 && f3!=f1 && l!=imin && l!=jmin && l!=kmin && l!=lmin && l!=imin1 && l!=jmin1 && l!=kmin1 && l!=lmin1) {
                      p0 = (f0+f1+f2+f3)/4.0;
                      s0 = (f0-p0)*(f0-p0)+(f1-p0)*(f1-p0)+(f2-p0)*(f2-p0)+(f3-p0)*(f3-p0);
                      if (s0<smin2 && MathAbs(p0-pmin)>minDiff*Point && MathAbs(p0-pmin1)>minDiff*Point && MathAbs(i-j)>minBars && MathAbs(i-k)>minBars && MathAbs(k-j)>minBars && MathAbs(i-l)>minBars && MathAbs(j-l)>minBars && MathAbs(k-l)>minBars) {
                         smin2=s0;
                         pmin2=p0;
                         imin2=i;
                         jmin2=j;
                         kmin2=k;
                         lmin2=l;
                      } 
                    }
                  }
                }
              }
            }
          }
        }       
      }

      //   PPZ  4- 
      for(i = loopbegin; i > Nfirst; i--) {
        f0 = -1.0; 
        f0 = iFractals(NULL,0,MODE_UPPER,i);
        if (f0<=0.0 ) f0 = iFractals(NULL,0,MODE_LOWER,i);
        if (f0>0.0 && i!=imin && i!=jmin && i!=kmin && i!=lmin && i!=imin1 && i!=jmin1 && i!=kmin1 && i!=lmin1 && i!=imin2 && i!=jmin2 && i!=kmin2 && i!=lmin2) {
          for(j = loopbegin; j > Nfirst; j--) { 
            f1=-1.0;
            f1 = iFractals(NULL,0,MODE_UPPER,j);
            if (f1<=0.0) f1 = iFractals(NULL,0,MODE_LOWER,j);
            if (f1>0.0 && f1!=f0 && j!=imin && j!=jmin && j!=kmin && j!=lmin && j!=imin1 && j!=jmin1 && j!=kmin1 && j!=lmin1 && j!=imin2 && j!=jmin2 && j!=kmin2 && j!=lmin2) {
              for(k = loopbegin; k > Nfirst; k--) { 
                f2 = -1.0;
                f2 = iFractals(NULL,0,MODE_UPPER,k);
                if (f2<=0.0 ) f2 = iFractals(NULL,0,MODE_LOWER,k);
                if (f2 >0.0 && f2!=f0 && f2!=f1 && k!=imin && k!=jmin && k!=kmin && k!=lmin && k!=imin1 && k!=jmin1 && k!=kmin1 && k!=lmin1 && k!=imin2 && k!=jmin2 && k!=kmin2 && k!=lmin2) {
                  for(l = loopbegin; l > Nfirst; l--) { 
                    f3 = -1.0;
                    f3 = iFractals(NULL,0,MODE_UPPER,l);
                    if (f3<=0.0 ) f3 = iFractals(NULL,0,MODE_LOWER,l);
                    if (f3 >0.0 && f3!=f0 && f3!=f1 && l!=imin && l!=jmin && l!=kmin && l!=lmin && l!=imin1 && l!=jmin1 && l!=kmin1 && l!=lmin1 && l!=imin2 && l!=jmin2 && l!=kmin2 && l!=lmin2) {
                      p0 = (f0+f1+f2+f3)/4.0;
                      s0 = (f0-p0)*(f0-p0)+(f1-p0)*(f1-p0)+(f2-p0)*(f2-p0)+(f3-p0)*(f3-p0);
                      if (s0<smin3 && MathAbs(p0-pmin)>minDiff*Point && MathAbs(p0-pmin1)>minDiff*Point && MathAbs(i-j)>minBars && MathAbs(i-k)>minBars && MathAbs(k-j)>minBars && MathAbs(i-l)>minBars && MathAbs(j-l)>minBars && MathAbs(k-l)>minBars) {
                         smin3=s0;
                         pmin3=p0;
                         imin3=i;
                         jmin3=j;
                         kmin3=k;
                         lmin3=l;
                      } 
                    }
                  }
                }
              }
            }
          }
        }       
      }

      // ,  
      
      B0[imin] = Open[imin];
      B0[jmin] = Open[jmin];
      B0[kmin] = Open[kmin];
      B0[lmin] = Open[lmin];
      
      B1[imin1] = Open[imin1];
      B1[jmin1] = Open[jmin1];
      B1[kmin1] = Open[kmin1];
      B1[lmin1] = Open[lmin1];

      B2[imin2] = Open[imin2];
      B2[jmin2] = Open[jmin2];
      B2[kmin2] = Open[kmin2];
      B2[lmin2] = Open[lmin2];

      B3[imin3] = Open[imin3];
      B3[jmin3] = Open[jmin3];
      B3[kmin3] = Open[kmin3];
      B3[lmin3] = Open[lmin3];

      if(!ObjectCreate("PPZ",OBJ_HLINE,0,Time[0],NormalizeDouble(pmin,Digits))) {
        Comment("ERROR");
        return(0);
      }
      if(!ObjectCreate("PPZ1",OBJ_HLINE,0,Time[0],NormalizeDouble(pmin1,Digits))) {
        Comment("ERROR");
        return(0);
      }
      if(!ObjectCreate("PPZ2",OBJ_HLINE,0,Time[0],NormalizeDouble(pmin2,Digits))) {
        Comment("ERROR");
        return(0);
      }
      if(!ObjectCreate("PPZ3",OBJ_HLINE,0,Time[0],NormalizeDouble(pmin3,Digits))) {
        Comment("ERROR");
        return(0);
      }
      
      if(!ObjectCreate("V1",OBJ_VLINE,0,Time[Nbars+Nfirst],Open[0])) {
        Comment("ERROR");
        return(0);
      }
      if(!ObjectCreate("V2",OBJ_VLINE,0,Time[Nfirst],Open[0])) {
        Comment("ERROR");
        return(0);
      }
      ObjectSet("PPZ",OBJPROP_COLOR,DeepSkyBlue);
      ObjectSet("PPZ",OBJPROP_STYLE,STYLE_DASH);

      ObjectSet("PPZ1",OBJPROP_COLOR,DeepPink);
      ObjectSet("PPZ1",OBJPROP_STYLE,STYLE_DASH);

      ObjectSet("PPZ2",OBJPROP_COLOR,Gold);
      ObjectSet("PPZ2",OBJPROP_STYLE,STYLE_DASH);

      ObjectSet("PPZ3",OBJPROP_COLOR,Tomato);
      ObjectSet("PPZ3",OBJPROP_STYLE,STYLE_DASH);

      ObjectSet("V1",OBJPROP_COLOR,DarkKhaki);
      ObjectSet("V2",OBJPROP_COLOR,DarkKhaki);
      
      calculated = true;
      Comment("Calculation of PPZ done \n PPZ0 " + DoubleToStr(pmin,5) + "\n PPZ1 " + DoubleToStr(pmin1,5) + "\n PPZ2 " + DoubleToStr(pmin2,5) + "\n PPZ3 " + DoubleToStr(pmin3,5) + "\n");
      return(0);
  }
//+------------------------------------------------------------------+



